<?php
// Admin ajax functions

// Create full system backup
add_action( 'wp_ajax_wpbu_do_full_backup', 'wpbu_do_full_backup' );
function wpbu_do_full_backup() {
	if(class_exists('WPBU_backup')){
		$backup = new WPBU_Backup();
		$backup = $backup->full_backup();
		print json_encode($backup);
	}
	exit;
}

// Create database backup
add_action( 'wp_ajax_wpbu_do_database_backup', 'wpbu_do_database_backup' );
function wpbu_do_database_backup() {
	if(class_exists('WPBU_backup')){
		$backup = new WPBU_Backup();
		$backup = $backup->Create_Database_Backup();
		print json_encode($backup);
	}
	exit;
}

add_action('wp_ajax_wpbu_remove_backup', 'wpbu_remove_backupup');
function wpbu_remove_backupup(){
	$params = $_POST;
	if(empty($params['backupID']))
		return;

	// @todo add feed back for errors
	$backup_location = get_post_meta($params['backupID'], 'backup_location', true);
	if(file_exists($backup_location) && !unlink($backup_location)){
		print '0';
		exit;
	}

	if( wp_delete_post($params['backupID'], true) ){
		print '1';
	}else{
		print '0';
	}
	exit;
}

/*
|--------------------------------------------------------------------------
| Unpack a backup
|--------------------------------------------------------------------------
|
| Returns a JSON object contain a tree structure of a given backup
|
*/
add_action('wp_ajax_wpbu_backup_browser', 'wpbu_backup_browser');
function wpbu_backup_browser(){

	$errors = array();
	$params = $_POST;

	// Make sure the backuID was given
	if(empty($params['backupID'])){
		array_push($errors, array( 'Missing backup parameter' ));
	}

	// Get the backup location for the backup CPT
	$backup_location = get_post_meta( $params['backupID'], 'backup_location', true );

	// make sure the backup exists
	if( ! file_exists( $backup_location ) ){
		array_push($errors, array( 'Backup does not exist' ));
	}

	// Report is there is any errors
	if( count( $errors ) > 0 ){
		print json_encode( array( 'errors' => $errors ) );
		exit;
	}

	// Awesome way to see size contents without unpacking
	// require_once( dirname(__FILE__) . '/pclzip.lib.php');
	// $archive = new PclZip( $backup_location );
	// print json_encode( flatToTree($archive->listContent()) );

	// exit;

	$backup_clone_location = WPBU_ABSPATH . '/options/tmp';
	if( ! file_exists( $backup_clone_location )){
		mkdir( $backup_clone_location, 0755);
	}
	$backup_clone_name = 'tmp-browser-data.zip';

	// Try to copy the backup to a temp location
	if( ! @copy( $backup_location, $backup_clone_location. '/' . $backup_clone_name ) ){
		array_push($errors, array( 'Failed to make a copy of the backup' ));
		print json_encode( array( 'errors' => $errors ) );
		exit;
	}

	$zip = new ZipArchive;
	$zip->open( $backup_clone_location. '/' . $backup_clone_name );
	
	$zip->extractTo( WPBU_ABSPATH . '/options/tmp/' );
	$zip->close();

	// Everything should be unpacked and now we only want the level 1 files and directories
	$files = listDirectoryByFolder( WPBU_ABSPATH . '/options/tmp' );

	// print_r($files);
	
	$dir_content = array();

	array_push($dir_content, array(
								'directory' => '/'
								));

	// Loop through the files in the root directory
	foreach($files as $file){
		$file_data['filename'] 	= basename($file);
		$file_data['is_dir'] 	= is_dir( WPBU_ABSPATH . '/options/tmp/' . basename($file) ) ? '1':'0';
		$file_data['file_size']	= filesize_formatted( filesize( WPBU_ABSPATH . '/options/tmp/' . basename($file) ));
		$file_data['file_type']	= pathinfo( WPBU_ABSPATH . '/options/tmp/' . basename($file), PATHINFO_EXTENSION );
		array_push($dir_content, $file_data);
		
	}

	print json_encode( $dir_content );
	exit;
}

/*
|--------------------------------------------------------------------------
| Options Close - Function 
|--------------------------------------------------------------------------
|
| Cleans the the temp directory used for backup browser
*/
add_action('wp_ajax_wpbu_options_window_close', 'wpbu_options_window_close');
function wpbu_options_window_close(){
	delTree( WPBU_ABSPATH . '/options/tmp' );
}